#include "stdafx.h"
#include "iis4ruby_cmn_page.h"

BOOL WriteHelpPage( IN EXTENSION_CONTROL_BLOCK *pECB ) {

	TCHAR sHelpMsg[]	= _T("<html>\r\n")
		_T("<head>\r\n")
		_T("</head>\r\n")
		_T("<body>\r\n")
		_T("<h1>Help Page</h1>\r\n")
		_T("</body>\r\n")
		_T("</html>\r\n") ;
	DWORD dwCntHelpMsg ;
	char sHeader[ 1024 ] ;
	BOOL bResult	= FALSE ;

	::ZeroMemory( sHeader, sizeof( sHeader ) ) ;

	dwCntHelpMsg	= sizeof( sHelpMsg ) - sizeof( TCHAR ) ;
	_snprintf_s( sHeader, sizeof( sHeader ), _TRUNCATE,
		"Content-Type: text/html\r\n"
		"Content-Length: %d\r\n\r\n", dwCntHelpMsg ) ;

	bResult	= pECB->ServerSupportFunction(
		pECB->ConnID, HSE_REQ_SEND_RESPONSE_HEADER, "200 OK", NULL, (DWORD*)sHeader ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;
	bResult	= pECB->WriteClient( pECB->ConnID, sHelpMsg, &dwCntHelpMsg, HSE_IO_SYNC ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;

	return TRUE ;
}

BOOL WriteErrorPage( IN EXTENSION_CONTROL_BLOCK *pECB, LPCTSTR pErrMsg ) {

	TCHAR sHelpMsg[]	= _T("<html>\r\n")
		_T("<head>\r\n")
		_T("</head>\r\n")
		_T("<body>\r\n")
		_T("<h1>Error Page</h1>\r\n")
		_T("<h2>%s</h2>\r\n")
		_T("</body>\r\n")
		_T("</html>\r\n") ;
	DWORD dwCntHelpMsg ;
	TCHAR sHelpMessage[ 1024 ] ;
	char sHeader[ 1024 ] ;
	BOOL bResult	= FALSE ;

	::ZeroMemory( sHeader, sizeof( sHeader ) ) ;
	::ZeroMemory( sHelpMessage, sizeof( sHelpMessage ) ) ;

	dwCntHelpMsg	= sizeof( sHelpMsg ) - sizeof( TCHAR ) ;

	_stprintf_s( sHelpMessage, sizeof( sHelpMessage ), sHelpMsg, pErrMsg ) ;
	dwCntHelpMsg	= _tcslen( sHelpMessage ) ;
	_snprintf_s( sHeader, sizeof( sHeader ), _TRUNCATE,
		"Content-Type: text/html\r\n"
		"Content-Length: %d\r\n\r\n", dwCntHelpMsg ) ;

	bResult	= pECB->ServerSupportFunction(
		pECB->ConnID, HSE_REQ_SEND_RESPONSE_HEADER, "200 OK", NULL, (DWORD*)sHeader ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;
	bResult	= pECB->WriteClient( pECB->ConnID, sHelpMessage, &dwCntHelpMsg, HSE_IO_SYNC ) ;
	CHK_RET_REL_SYSTEM( bResult ) ;

	return TRUE ;
}
