////////////////////////////////////////////////////////////////
//
// dllmain.cpp
//
////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "..\\iis4ruby_cmn\\iis4ruby_cmn_err.h"
#include "..\\iis4ruby_cmn\\Message.h"

extern TCHAR sRubyCmd[ 1024 ] ;
extern TCHAR sDllName[ 1024 ] ;
extern TCHAR sRunCmd[ 2048 ] ;

//
//
//
//
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:{
			REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("DllMain:DLL_PROCESS_ATTACH") ) ;
			InitCmnLib( hModule ) ;
			::ZeroMemory( sRubyCmd, sizeof( sRubyCmd ) ) ;
			::GetModuleFileName( hModule, sDllName, sizeof( sDllName ) - sizeof( TCHAR ) ) ;
			TCHAR* pPointer	= _tcsrchr( sDllName, '.' ) ;
			pPointer[ 0 ]	= '\0' ;
			_tcscat_s( sDllName, sizeof( sDllName ) - sizeof( TCHAR ), _T(".ini") ) ;
			
			::GetPrivateProfileString( _T("ruby"), _T("path"), _T("ruby.exe"), sRubyCmd, sizeof( sRubyCmd ) - sizeof( TCHAR ), sDllName ) ;

			_stprintf_s( sRunCmd, sizeof( sRunCmd ), _T("\"%s\" \"%%s\""), sRubyCmd ) ;
			}
			break ;
	case DLL_THREAD_ATTACH:
			REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("DllMain:DLL_THREAD_ATTACH") ) ;
			break ;
	case DLL_THREAD_DETACH:
			REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("DllMain:DLL_THREAD_DETACH") ) ;
			break ;
	case DLL_PROCESS_DETACH:
			REL_INFO( CAT_REV1, MSG_REV1_INFO, _T("DllMain:DLL_PROCESS_DETACH") ) ;
			break;
	}
	return TRUE;
}
